function groups = gecluster(dists, together, thr_t)

%  thr_t = 100;
  
  % initialise clustures by individuals
  for I=1:size(dists, 1)
    C{I} = I;
  end
  K = size(dists, 1);			% number of clusters
  dists = min(dists, dists');		% upper diagonal to full matrix
  cdists = dists;
  ro = max(together, together') > thr_t;
  true_e = zeros(1, size(cdists, 1));

  exp_e = zeros(1, 20);
  for J=1:2:length(exp_e)		% odd
    exp_e(J) = (J - 1) / 2 * (1 + (J - 1) / 2);
  end
  for J=2:2:length(exp_e)		% even
    exp_e(J) = J * J / 4;
  end
  
  while 1
    [mind, bestidx] = min(cdists(:));
    [bestI, bestJ] = ind2sub(size(cdists), bestidx);

    if mind == Inf
        break;
    end
    
    kI = length(C{bestI});
    kJ = length(C{bestJ});

    both_e = sum(sum(ro(C{bestI}, C{bestJ})));
    if both_e <  exp_e(kI + kJ) + ...
	  (true_e(bestI) - exp_e(kI) + true_e(bestJ) - exp_e(kJ))
      cdists(bestI, bestJ) = Inf;
      cdists(bestJ, bestI) = Inf;
    else	% intra-group tightness criterion fulfilled -> merge
      I = min(bestI, bestJ);
      idx_max = max(bestI, bestJ);
      C{I} = [C{bestI} C{bestJ}];
      C(idx_max) = [];
      true_e(I) = both_e;
      true_e(idx_max) = [];
      cdists(idx_max, :) = [];
      cdists(:, idx_max) = [];
      K = K - 1;
      
      % update cdists
      for J=1:size(K)
	if J == I, continue; end

	hAB = 0;
	for A = 1:length(C{I})
	  dij = sort(dists(C{I}(A), C{J}));
	  hAB = hAB + sum(dij(1:ceil(length(C{J}) / 2)));
	end
	hAB = hAB / (length(C{I}) * ceil(length(C{J}) / 2));

	hBA = 0;
	for B = 1:length(C{J})
	  dij = sort(dists(C{J}(B), C{I}));
	  hBA = hBA + sum(dij(1:ceil(length(C{I}) / 2)));
	end
	hBA = hBA / (length(C{J}) * ceil(length(C{I}) / 2));
	
	cdists(I, J) = (hAB + hBA) / 2;
	cdists(J, I) = (hAB + hBA) / 2;
      end
    end
  end
  
  groups = zeros(1, size(dists, 1));
  gid = 1;
  for I=1:K
    if length(C{I}) > 1
      groups(C{I}) = gid;
      gid = gid + 1;
    end
  end
  
  