function [fp, fn] = group_compare(groupsA, groupsB)

  fp = [];
  fn = [];
  
  for I=1:length(groupsA)
    group_id = groupsA(I);
    group = [];
    if group_id ~= 0
      group = find(groupsA == group_id);
      group(group == I) = [];
    end

    found_group = [];
    if groupsB(I) ~= 0
      found_group = find(groupsB == groupsB(I));
      found_group(found_group == I) = []; % remove self
    end
    
    if group_id == 0 & ~isempty(found_group)
      fg_tmp = found_group;
      fg_tmp(fg_tmp < I) = [];
      fp = [fp; [fg_tmp', ...
		 I * ones(length(fg_tmp), 1), ...
		 groupsA(fg_tmp)', ...
		 zeros(length(fg_tmp), 1)]];
    end

    if group_id ~= 0
      fps = setdiff(found_group, group);
      fps(fps < I) = [];
      if ~isempty(fps)
	fp = [fp; [fps', I * ones(length(fps), 1), ...
		   groupsA(fps)', ...
		   group_id * ones(length(fps), 1)]];
      end

      fns = setdiff(group, found_group);
      fns(fns < I) = [];
      if ~isempty(fns)
	fn = [fn; [fns', I * ones(length(fns), 1), ...
		   group_id * ones(length(fns), 1)]];
      end
    end
  end

  return;
  